
# <u><b>Create Fact</b></u>

### <u>Dependency: MMT-Fact already implemented</u>

In all Array-like structures, always add your facts at the bottom. 

1. In Assets\InteractionEngine\FactHandling\Facts create your own fact

    <u>Your fact should include</u>:

    (<i>use the already existing Facts as examples</i>)
    <br>

    1. 	A constructor that calls base(). Constructor can have SomDoc, which is the MMT URI as OMS.
        Only set the ServerDefinition inside the constructor if you have a good reason to.

    2. 	define: A method parseFact(List<Fact> ret, MMTFact fact). 
            convert MMTFact fact to Unity Fact and add it to the List<Fact> ret

            hint: use FactRecorder.AllFacts[<uri>] to get the Unity Fact belonging to the <uri>

    3.	define: public override bool HasDependentFact => [true/false]	

    4.	define: GetDeendentFactIds(), which gives back a string array of the dependent URIs of your facts.

    5.	define: GetHashCode()

    6. 	define: EquivalentWrapped(YOUR_FACTCLASS, YOUR_FACTCLASS), which is a Method that
            returns true if the two facts are (approximately) equal

    7.	define: _ReInitializeMe(Dictionary<string, string> old_to_new), that gets called when the Fact
            gets reinstantiated

    8.	define: MakeMMTDecalaration(), which gives back a new MMTFact.
    
    9.	define: Defines(), which gives back a SOMDoc(MMTObject) of your class

2. Add the MMT-fact you Implemented into Assets\Scripts\MMTServer\CommunicationProtocol\MMTConstants.cs
   in OMS_TO_TYPE add a line like:
            {
                ObjectType,
                typeof(ObjectFact)
            },


3. Then, in Assets\Scripts\InteractionEngine\FactHandling\Facts\Fact.cs
    
    1. add an entry into ParsingDictionary.parseFactDictionary with your MMTConstant as key and the parseFact Method of the Fact class you implemented.

    2. Then add a line to the lines that look like 
    [JsonSubtypes,.KnownSubType(typeof(YOUR_FACTCLASS), nameof(YOUR_FACTCLASS))]

4. In Assets\Scripts\InteractionEngine\FactHandling\FactSpawner.cs

    1. Add a variable of type GameObject for your fact.
    2. Create a spawn method for your fact.
    3. In SpawnFactRepresentation add your Fact to the switch-case statement

5. In the Unity Editor in Assets\Ressources\Prefabs\Facts create the prefab for your Fact. 

6. Connect your Prefab to the FactSpawner class

    1. Open Assets\Scenes\Worlds\RiverWorld. 
    2. In the Unity Project Tab goto folder Assets\Scripts\InteractionEngine\FactHandling
    3. Rightclick FactSpawner.cs and select "Find References In Scene".
    4. In Hirarchy select WorldCursor and add your Fact Prefab into the Inspector.
    5. Alternative to 6.2 & 6.3: in hirarchy search: "ref:Assets/Scripts/InteractionEngine/FactHandling/FactSpawner.cs"

7. Create an Icon for your Fact

    1.  Create an Icon-image
        1.1 Create an icon-image with dimensions: 200x200 and save it into: "Assets\Scripts\InventoryStuff\Items\images"
        1.2 Change the "Texture Type" to: "Sprite (2D and UI)", the "Sprite Mode" to "single" and finally the "Pixel per unit" to "256".
    2.  Create the prefab for you facticon in: "Assets\Resources\Prefabs\UI\Icons\FactIcons" by copying an existing prefab.
        2.1 Drag your created sprite into "Source Image"
        2.2 Add or remove additional points associated with your prefab, then edit the variable: "Fact Text" in the script "Fact Object UI".  
    4.  Open: "Assets\Scenes\Worlds\River World"
    5.  Then search for "DisplayFacts" and open "Factscreen".
    6.  In both factscreens search for the rownumber of your factclass in "Prefabt Type Readonly" (yes, this is the real name not a typo),
        then drag your created prefab into "Prefab Data Config" into the row with the same rownumber.